<?php
/**
 *
 * @category        modules
 * @package         404 page redirect
 * @author          Ruud Eisinga / Dev4me
 * @link			http://www.dev4me.nl/modules-snippets/opensource/404/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 5.6 and higher
 * @version         1.5.0
 * @lastmodified    June 21, 2020
 *
 *
 */

// prevent this file from being accessed directly
if(!defined('WB_PATH')) die(header('Location: index.php'));  

// Look for language file
require_once(WB_PATH.'/modules/mod404/languages/EN.php');
if(file_exists(WB_PATH.'/modules/mod404/languages/'.LANGUAGE.'.php')) {
	require_once(WB_PATH.'/modules/mod404/languages/'.LANGUAGE.'.php');
}
require_once (WB_PATH.'/modules/mod404/functions.php');

$link = $database->get_one("SELECT link FROM ".TABLE_PREFIX."pages WHERE `page_id` = '$page_id'");
$email = $database->get_one("SELECT `email` FROM ".TABLE_PREFIX."mod_404_cfg LIMIT 1");
$subject = $database->get_one("SELECT `subject` FROM ".TABLE_PREFIX."mod_404_cfg LIMIT 1");
$interval = $database->get_one("SELECT `interval` FROM ".TABLE_PREFIX."mod_404_cfg LIMIT 1");
$storeip = $database->get_one("SELECT `storeip` FROM ".TABLE_PREFIX."mod_404_cfg LIMIT 1");
$withref = $database->get_one("SELECT `withref` FROM ".TABLE_PREFIX."mod_404_cfg LIMIT 1");
$bakery = $database->get_one("SELECT `bakery` FROM ".TABLE_PREFIX."mod_404_cfg LIMIT 1");
$oneforall = $database->get_one("SELECT `oneforall` FROM ".TABLE_PREFIX."mod_404_cfg LIMIT 1");
if(!$subject) $subject = $MOD_404['TXT_SUBJECT'];

if (!isset($links_404)) {
	$links_404 = array();
	_404_build_pagelist(0,$page_id,$bakery,$oneforall);
}
$sel = ' selected';

$wrong = array();
$result = $database->query("SELECT * FROM ".TABLE_PREFIX."mod_404 ORDER BY `404_id`");
if ($result && $result->numRows() > 0) {
	while($row = $result->fetchRow()){
		$wrong[$row['404_id']] = $row['404_right'].SEP1.$row['404_wrong'].SEP1.$row['404_link'];
	}
}
?>  
	<hr><h2><?php msg("TXT_TITLE") ?></h2>
	
	<table style="width: 100%;padding:10px;margin-bottom:15px;box-shadow:0 0 1px #111;border:0px solid #303641; background:#ddd;"  cellpadding="3" cellspacing="0" border="0" >
		<tr>
			<td>
				<a href="#" onclick=" $('#404rules').toggle();	$('#404config,#404help,#404history').hide();	return false;"><?php msg("TXT_RULES") ?></a> | 
				<a href="#" onclick=" $('#404config').toggle();	$('#404rules,#404help,#404history').hide();		return false;"><?php msg("TXT_CONFIG") ?></a> |
				<a href="#" onclick=" $('#404history').toggle();$('#404config,#404rules,#404help').hide();		return false;"><?php msg("TXT_HISTORY") ?></a>
				<a style="float:right" href="#" onclick=" $('#404help').toggle(); 	$('#404config,#404rules,#404history').hide();	return false;"><?php msg("TXT_HELP") ?></a>
			</td>
		</tr>
	</table>

	
	<div id="404help" style="box-shadow:0 0 1px #111;background:#fcc;padding:5px 10px;margin-bottom:10px; display:none">
		<?php if(file_exists(WB_PATH.'/short.php')) { ?>
			<strong><?php msg("TXT_SHORTPHP") ?></strong><br><br>
			define('ERROR_PAGE', '<?php echo $link ?>/'); 
		<?php } elseif (file_exists(WB_PATH.'/wb.php')) { ?>
			<strong><?php msg("TXT_WBPHP") ?></strong><br><br>
			define('ERROR_PAGE', '<?php echo $link ?>/'); 
		<?php } else {?>
			<strong><?php msg("TXT_LEGEND") ?></strong><br><br>
			ErrorDocument 404 <?php echo PAGES_DIRECTORY.$link.PAGE_EXTENSION ?>
		<?php } ?>
	</div>
	
	
	<div id="404config" style="box-shadow:0 0 1px #111;background:#fafafa;padding:5px 10px;margin-bottom:10px;display:none">
		<table class="mod_404_table" cellpadding="2" cellspacing="2" border="0" width="100%">
			<tr><td colspan="3"><strong><?php msg("TXT_CONFIG") ?></strong></td></tr>
				<form name="edit" action="<?php echo WB_URL; ?>/modules/mod404/save.php" method="post">
					<input type="hidden" name="page_id" value="<?php echo $page_id ?>" />
					<input type="hidden" name="config" value="1" />
					<tr>
						<td style="width:350px;"><?php msg("TXT_EMAIL") ?></td>
						<td><input style="width:98%" type="text" name="email" value="<?php echo $email; ?>"/></td>
					</tr>	
					<tr>
						<td style="width:350px;"><?php msg("TXT_EMAILSUB") ?></td>
						<td><input style="width:98%" type="text" name="subject" value="<?php echo $subject; ?>"/></td>
					</tr>	
					<tr>
						<td style="width:350px;"><?php msg("TXT_INTERVAL") ?></td>
						<td>
							<select name="interval">
								<option <?php if($interval=='0') { echo 'selected'; } ?> value='0'><?php msg('TXT_INT0') ?></option>
								<option <?php if($interval=='3') { echo 'selected'; } ?> value='3'><?php msg('TXT_INT3') ?></option>
								<option <?php if($interval=='6') { echo 'selected'; } ?> value='6'><?php msg('TXT_INT6') ?></option>
								<option <?php if($interval=='12') { echo 'selected'; } ?> value='12'><?php msg('TXT_INT12') ?></option>
								<option <?php if($interval=='24') { echo 'selected'; } ?> value='24'><?php msg('TXT_INT24') ?></option>
							</select>
							<?php msg("TXT_INTHELP") ?>
						</td>
					</tr>	
<?php if( _404_ofa_used (0)) { ?>
					<tr>
						<td style="width:350px;"><?php msg("TXT_BAKERY") ?></td>
						<td>
							<select name="bakery">
								<option <?php if($bakery=='0') { echo 'selected'; } ?> value='0'><?php msg('TXT_NO') ?></option>
								<option <?php if($bakery=='1') { echo 'selected'; } ?> value='1'><?php msg('TXT_YES') ?></option>
							</select>
						</td>
					</tr>
<?php } ?>
<?php if( _404_ofa_used (1)) { ?>
					<tr>
						<td style="width:350px;"><?php msg("TXT_OFA") ?></td>
						<td>
							<select name="oneforall">
								<option <?php if($oneforall=='0') { echo 'selected'; } ?> value='0'><?php msg('TXT_NO') ?></option>
								<option <?php if($oneforall=='1') { echo 'selected'; } ?> value='1'><?php msg('TXT_YES') ?></option>
							</select>
						</td>
					</tr>	
<?php } ?>
					<tr>
						<td style="width:350px;"><?php msg("TXT_WITHREF") ?></td>
						<td>
							<select name="withref">
								<option <?php if($withref=='0') { echo 'selected'; } ?> value='0'><?php msg('TXT_NO') ?></option>
								<option <?php if($withref=='1') { echo 'selected'; } ?> value='1'><?php msg('TXT_YES') ?></option>
							</select>
						</td>
					</tr>	
					<tr>
						<td style="width:350px;"><?php msg("TXT_STOREIP") ?></td>
						<td>
							<select name="storeip">
								<option <?php if($storeip=='0') { echo 'selected'; } ?> value='0'><?php msg('TXT_NO') ?></option>
								<option <?php if($storeip=='1') { echo 'selected'; } ?> value='1'><?php msg('TXT_YES') ?></option>
							</select>
						</td>
					</tr>						
					<tr>
						<td colspan="2">					
						<input type="submit" value="<?php msg("TXT_SAVE") ?>"/>
						</td>
					</tr>
				</form>
			</tr>
		</table>
	</div>

	<div id="404rules" style="box-shadow:0 0 1px #111;background:#fafafa;padding:5px 10px;margin-bottom:10px;display:none">
	<table class="mod_404_table" cellpadding="2" cellspacing="2" border="0" width="100%">
		<tr>
			<td valign="top" width="60%"><strong><?php msg("TXT_ERRORURL") ?></strong></td>
			<td valign="top" width="30%"><strong><?php msg("TXT_REDIRPAGE") ?></strong></td>
			<td valign="top">&nbsp;</td>
		</tr>
		<?php foreach ($wrong as $id => $value) { 
			$d = explode(SEP1,$value);
		?>
		<tr>
			<form name="edit" action="<?php echo WB_URL; ?>/modules/mod404/save.php" method="post">
			<input type="hidden" name="page_id" value="<?php echo $page_id ?>" />
			<input type="hidden" name="id" value="<?php echo $id ?>" />
			<td valign="top"><input style="width:95%;" type="text" name="wrong" value="<?php echo $d[1]; ?>"/></td>
			<td valign="top">
				<select name="redir_id" style="font-family:monospace; font-size:12px; width:95%;" />
				<option value="0"<?php echo $d[0]=='0' ? $sel : '' ?>><?php msg("TXT_SELECT") ?></option>
				<?php foreach($links_404 AS $li) {
					echo $li.'<br>';
					$option_link = explode(SEP4,$li);
					$disabled = $option_link[0] ? '':' disabled';
					echo "<option $disabled value=\"".$option_link[0]."\" ".($d[0]==$option_link[0] ? $sel : '').">$option_link[1]</option>\n";
					if($option_link[2]) {
						$extra = explode(SEP2,$option_link[2]);
						foreach($extra AS $e_li) {
							$e_option_link = explode(SEP3,$e_li);
							echo "<option value=\"".$e_option_link[0]."\" ".($d[2]==$e_option_link[0] ? $sel : '')."> => $e_option_link[1]</option>\n";
						}
					}
				} ?>
				</select>
			</td>
			<td valign="top"><input type="submit" value="<?php msg("TXT_UPDATE") ?>"/></td>
			</form>
		</tr>
		<?php } ?>
		<tr>
			<td valign="top"><strong><?php msg("TXT_NEW") ?></strong></td>
			<td valign="top">&nbsp;</td>
			<td valign="top">&nbsp;</td>
		</tr>
	
		<tr>
			<form name="add" action="<?php echo WB_URL; ?>/modules/mod404/save.php" method="post">
			<input type="hidden" name="page_id" value="<?php echo $page_id ?>" />
			<input type="hidden" name="id" value="0" />
			<td valign="top"><input style="width:95%;" type="text" name="wrong" value=""/></td>
			<td valign="top">
				<select name="redir_id" style="font-family:monospace;font-size:12px;  width:95%;" />
				<option value="0"><?php msg("TXT_SELECT") ?></option>
				<?php foreach($links_404 AS $li) {
					$option_link = explode(SEP4,$li);
					echo "<option value=\"".$option_link[0]."\">$option_link[1]</option>\n";
					if($option_link[2]) {
						$extra = explode(SEP2,$option_link[2]);
						foreach($extra AS $e_li) {
							$e_option_link = explode(SEP3,$e_li);
							echo "<option value=\"".$e_option_link[0]."\">=> $e_option_link[1]</option>\n";
						}
					}
				} ?>
				</select>
			</td>
			<td valign="top"><input type="submit" value="<?php msg("TXT_ADDNEW") ?>"/></td>
			</form>
		</tr>

		</table>
	</div>
	
	
	<div id="404history" style="width; 100%; max-width: 100%; max-height: 500px; overflow:auto; box-shadow:0 0 1px #111;background:#eee;padding:5px 10px;margin-bottom:10px;display:none">
		<div style="min-width; 100%;">
			<?php echo _404_history() ?>
		</div>
	</div>
	
	<table cellpadding="0" cellspacing="0" border="0" width="100%">
		<tr>
			<td align="left">
				<input type="button" value="<?php echo $TEXT['CANCEL']; ?>" onclick="javascript: window.location = '<?php echo ADMIN_URL; ?>/pages/index.php'; return false;" style="width: 100px; margin-top: 5px;" />
			</td>
		</tr>
	</table>
	</form>
	<hr>

