<?php
/**
 *
 * @category        modules
 * @package         404 page redirect
 * @author          Ruud Eisinga / Dev4me
 * @link			http://www.dev4me.nl/modules-snippets/opensource/404/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 5.6 and higher
 * @version         1.5.0
 * @lastmodified    June 21, 2020
 *
 *
 */
 
// prevent this file from being accessed directly
if(!defined('WB_PATH')) die(header('Location: index.php'));  

function _db_add_field($field, $table, $desc) {
	global $database;
	$table = TABLE_PREFIX.$table;
	$query = $database->query("DESCRIBE $table '$field'");
	if(!$query || $query->numRows() == 0) { // add field
		$query = $database->query("ALTER TABLE $table ADD $field $desc");
	}
}

// If errors table does not exist..
$mod_create_table = 'CREATE TABLE IF NOT EXISTS `' .TABLE_PREFIX .'mod_404_errors` ( '
	. '`id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,'
	. '`url` VARCHAR(1024) NOT NULL DEFAULT \'\','
	. '`referer` VARCHAR(1024) NOT NULL DEFAULT \'\','
	. '`redirect` VARCHAR(1024) NOT NULL DEFAULT \'\','
	. '`timestamp` INT(11) NOT NULL DEFAULT \'0\','
	. '`ip` VARCHAR(32) NOT NULL DEFAULT \'\','
	. '`host` VARCHAR(256) NOT NULL DEFAULT \'\','
	. '`browser` VARCHAR(1024) NOT NULL DEFAULT \'\','
	. '`warning` INT(1) NOT NULL DEFAULT \'0\','
	. 'PRIMARY KEY (id),'
	. 'INDEX `url` (`url`)'
	. ' )';
$database->query($mod_create_table);
// if config table does not exist
$mod_create_table = 'CREATE TABLE IF NOT EXISTS `' .TABLE_PREFIX .'mod_404_cfg` ( '
	. '`id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,'
	. '`email` VARCHAR(256) NOT NULL DEFAULT \'\','
	. '`subject` VARCHAR(256) NOT NULL DEFAULT \'\','
	. '`interval` INT(5) NOT NULL DEFAULT \'0\','
	. '`last` INT(11) NOT NULL DEFAULT \'0\','
	. '`storeip` INT(1) NOT NULL DEFAULT \'1\','
	. 'PRIMARY KEY (`id`)'
	. ' )';
$database->query($mod_create_table);

_db_add_field("`404_language`","mod_404", "VARCHAR(2) NOT NULL DEFAULT ''");
_db_add_field("`404_link`","mod_404", "VARCHAR(1024) NOT NULL DEFAULT ''");
_db_add_field("`404_order`","mod_404", "INT(11) NOT NULL DEFAULT '0'");

_db_add_field("`redirect`","mod_404_errors", "VARCHAR(1024) NOT NULL DEFAULT ''");
_db_add_field("`ip`","mod_404_errors", "VARCHAR(32) NOT NULL DEFAULT ''");
_db_add_field("`host`","mod_404_errors", "VARCHAR(256) NOT NULL DEFAULT ''");
_db_add_field("`browser`","mod_404_errors", "VARCHAR(1024) NOT NULL DEFAULT ''");

_db_add_field("`interval`","mod_404_cfg", "INT(5) NOT NULL DEFAULT '0'");
_db_add_field("`last`","mod_404_cfg", "INT(11) NOT NULL DEFAULT '0'");
_db_add_field("`storeip`","mod_404_cfg", "INT(1) NOT NULL DEFAULT '1'");
_db_add_field("`withref`","mod_404_cfg", "INT(1) NOT NULL DEFAULT '1'");
_db_add_field("`bakery`","mod_404_cfg", "INT(1) NOT NULL DEFAULT '0'");
_db_add_field("`oneforall`","mod_404_cfg", "INT(1) NOT NULL DEFAULT '0'");



?>